%------------------------------------------------------------------------
% Description: This code implements the paper: 
% "Image Segmentation with Cage Active Contours" Llus Garrido, Marit Guerrieri, Laura Igual
%
% Coded by: Llus Garrido and Laura Igual 
%------------------------------------------------------------------------


function [mask_out, its] = runCAC(mask, dist, numpoints, band)

[y x] = find(mask > 0);
ry=(max(y)-min(y)+1)/2;
rx=(max(x)-min(x)+1)/2;
cy=mean(y);
cx=mean(x);

% Using 8 (resp. 16) control points:
angle = (0:360/numpoints:359)*pi/180;
C = [cx + (rx + dist) * cos(angle)', cy + (ry + dist) * sin(angle)'];
save -ascii cage.txt C
imwrite(mask, 'mask.pgm')

command = sprintf('./cac 1 img.pgm mask.pgm cage.txt %d', band);
system(command);

mask_tmp = imread('mask_final.pgm');
mask_out = zeros(size(mask_tmp));
mask_out(find(mask_tmp>0)) = 255;


process_iterations = load('gradient_descent.log');
its = length(process_iterations);




